# -*- coding: utf-8 -*-
#Copyright (C) 2012 Red Hat, Inc.

from trac.config import Option
from trac.core import Component, implements
from trac.ticket.api import ITicketManipulator
from trac.ticket.model import Milestone


class FillInTheDefaultDueDate(Component):
    implements(ITicketManipulator)

    field = Option('ticket-duedate', 'field', 'duedate',
                   doc="Ticket field that contains the ticket due date.")

    ### ITicketManipulator methods

    def prepare_ticket(self, req, ticket):
        pass

    def validate_ticket(self, req, ticket):

        if not ticket.exists and ticket['milestone']:
            milestone = Milestone(self.env, ticket.values['milestone'])
            if milestone and milestone.due and \
                self.field in ticket.values and not ticket.values[self.field]:
                ticket.values[self.field] = milestone.due

        return []


